from __future__ import annotations

import time
from abc import abstractmethod
from subprocess import Popen
from typing import TYPE_CHECKING, Any, Tuple

from loguru import logger

if TYPE_CHECKING:
    from aaambos.core.supervision.arch_supervisor import ArchSupervisor
    from aaambos.core.configuration.pre_execution_config import PreExecutionConfig


class PreExecution:
    """Base class for pre executing before the modules run."""

    def __init__(self, pre_execution_configs: list[PreExecutionConfig], supervisor: ArchSupervisor):
        self.configs = pre_execution_configs
        self.supervisor = supervisor

    @abstractmethod
    def check_configs(self) -> bool:
        ...

    @abstractmethod
    def pre_execute(self) -> int | float:
        ...

    def terminate(self):
        ...


class ShellPreExecution(PreExecution):
    """Execute a shell command before the modules run.

    The 'execute' attribute is the argument for the Popen class.
    In the miscellaneous you can specify kwargs for the Popen class and:
    - 'wait_for_termination' (bool) the modules of the architecture will not start before the Popen terminates. Default: True
    - 'can_fail' (bool) if present and True the executor will not raise an Exception if the Popen terminates with a failure. Default: False
    - 'create_command_with_supervisor_data' (Callable[[config=PreExecutionConfig, supervisor=ArchSupervisor], str | list]) can reference a function that creates the shell command when the supervisor data is needed or should be generated by an external function during run time.

    Example:
        ```yaml
        my_pre_shell_command:
            executor_class: !name:aaambos.core.supervision.pre_execution.ShellPreExecution  # default
            execute: ["nanomq", "start"]
            miscellaneous:
                shell: True
                wait_for_termination: False
        ```
    """
    def __init__(self, pre_execution_configs: list[PreExecutionConfig], supervisor: ArchSupervisor):
        super().__init__(pre_execution_configs=pre_execution_configs, supervisor=supervisor)
        self.subprocesses: dict[str, Tuple[Popen, PreExecutionConfig]] = {}

    def check_configs(self) -> bool:
        return all([isinstance(config, (list, str)) for config in self.configs])

    def pre_execute(self):
        for config in self.configs:
            if "create_command_with_supervisor_data" in config.miscellaneous:
                if callable(config.miscellaneous["create_command_with_supervisor_data"]):
                    command = config.miscellaneous["create_command_with_supervisor_data"](config=config, supervisor=self.supervisor)
                else:
                    logger.error(f"'create_command_with_supervisor_data' must be callable. Miscellaneous config argument for a ShellPreExecution. Name of the execution: {config.name!r}")
                    continue
            else:
                command = config.execute
            self.subprocesses[config.name] = (Popen(command, **self.prepare_kwargs(config)), config)
        start_time = time.time()
        for name, (subprocess, config) in self.subprocesses.items():
            if "wait_for_termination" not in config.miscellaneous or config.miscellaneous["wait_for_termination"]:
                logger.trace(f"Wait for ShellPreExecution {config.name!r} to terminate.")
                return_code = subprocess.wait()
                if return_code and "can_fail" not in config.miscellaneous:
                    logger.error(f"ShellPreExecution: {config.name!r} - failed with return code {return_code}.")
                    if subprocess.stderr:
                        logger.error(subprocess.stderr.readlines())
                    raise RuntimeError(f"ShellPreExecution {config.name!r} failed. Either add 'can_fail' in the miscellaneous part of the config or fix the error.")
                if "add_output_to_log" in config.miscellaneous:
                    if subprocess.stdout:
                        logger.trace(subprocess.stdout.readlines())
                    if subprocess.stderr:
                        logger.error(subprocess.stderr.readlines())
        return max([config.additional_sleep_time for _, config in self.subprocesses.values()]) - (time.time() - start_time)

    @staticmethod
    def prepare_kwargs(config: PreExecutionConfig) -> dict[str, Any]:
        kwargs = config.miscellaneous.copy()
        if "wait_for_termination" in kwargs:
            del kwargs["wait_for_termination"]
        if "can_fail" in kwargs:
            del kwargs["can_fail"]
        if "add_output_to_log" in kwargs:
            del kwargs["add_output_to_log"]
        if "create_command_with_supervisor_data" in kwargs:
            del kwargs["create_command_with_supervisor_data"]
        return kwargs

    def terminate(self):
        for subprocess, config in self.subprocesses.values():
            if subprocess.returncode is None:
                logger.info(f"Terminate ShellPreExecution subprocess {config.name}")
                subprocess.terminate()


class PyFuncPreExecution(PreExecution):
    """Call a Python function before modules run.

    Per default no args or kwargs are passed to the function.
    - You can add the config of the PreExecution (of type `PreExecutionConfig`) with the `add_config` attribute inside the miscellaneous attribute of the config.
    - The function can also get access to the `supervisor` via the `add_supervisor` attribute in the miscellaneous attribute. It is also passed via a kwarg (`supervisor`)

    With the miscellaneous attribute in the config you can also pass other configuration information to your function:
    ```yaml
    my_pre_func:
        executor_class: !name:aaambos.core.supervision.pre_execution.PyFuncPreExecution
        execute: !name:my_pkg.my_file.my_func
        miscellaneous:
            add_config: True
            my_config_attribute: 123456789
            add_supervisor: True
    ```
    would result in the call: `my_func(config, supervisor)`
    """

    def check_configs(self) -> bool:
        return all([callable(config.execute) for config in self.configs])

    def pre_execute(self):
        for config in self.configs:
            config.execute(**self.prepare_kwargs(config))

        return max([config.additional_sleep_time for config in self.configs])

    def prepare_kwargs(self, config: PreExecutionConfig) -> dict[str, Any]:
        kwargs = {}
        if "add_config" in config.miscellaneous and config.miscellaneous["add_config"]:
            kwargs["config"] = config
        if "add_supervisor" in config.miscellaneous and config.miscellaneous["add_supervisor"]:
            kwargs["supervisor"] = self.supervisor

        return kwargs

